# include "stdio.h"
#ifdef __cplusplus
   extern "C" {
     extern int yyreject();
     extern int yywrap();
     extern int yylook();
     extern void main();
     extern int yyback(int *, int);
     extern int yyinput();
     extern void yyoutput(int);
     extern void yyunput(int);
     extern int yylex();
   }
#endif	/* __cplusplus */
# define U(x) x
# define NLSTATE yyprevious=YYNEWLINE
# define BEGIN yybgin = yysvec + 1 +
# define INITIAL 0
# define YYLERR yysvec
# define YYSTATE (yyestate-yysvec-1)
# define YYOPTIM 1
# define YYLMAX 200
# define output(c) putc(c,yyout)
/*
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
# define unput(c) {yytchar= (c);if(yytchar=='\n')yylineno--;*yysptr++=yytchar;}
*/
# define yymore() (yymorfg=1)
# define ECHO fprintf(yyout, "%s",yytext)
# define REJECT { nstr = yyreject(); goto yyfussy;}
int yyleng;
int yylenguc;
extern unsigned char yytextarr[];
extern unsigned char yytext[];
int yyposix_point=0;
int yynls16=0;
int yynls_wchar=0;
char *yylocale = "/\001:C;\002:C;\003:C;\004:C;:C;:C;:C;/";
int yymorfg;
extern unsigned char *yysptr, yysbuf[];
int yytchar;
FILE *yyin, *yyout;
//FILE *yyin = {stdin}, *yyout = {stdout};
extern int yylineno;
struct yysvf { 
	int yystoff;
	struct yysvf *yyother;
	int *yystops;};
struct yysvf *yyestate;
extern struct yysvf yysvec[], *yybgin;
#include "fktdef.h"
#include "f_parse.h"

extern Psymbol *Plookup();

extern int *S_tab;
static short mfkdef = 0;	/* Makro/Funktions-Definition aktiv ? */
extern short mfkpar;            /* Makro/Funktions-Parameter aktiv ? */
# define YYNEWLINE 10
yylex(){
   int nstr; extern int yyprevious;
   while((nstr = yylook()) >= 0)
yyfussy: switch(nstr){
case 0:
   if(yywrap()) return(0); break;
case 1:
{ ; }
break;
case 2:
{
	sscanf( (char*) yytext, "%le", &yylval.val.u.s );
	yylval.val.type = 1;
	return NUMBER;
	}
break;
case 3:
{
	Symbol *s;

	if ( yyleng == 1 )
	{
	   short  i;
	   extern short F_dim;
	   extern char Param[];
	   extern double Parval[];

	   if ( mfkdef )
	   {
	      yylval.mfe = emalloc(1);
	      *yylval.mfe = yytext[0];
	      return MFKTPAR;
	   }
	   else if ( mfkpar )
	   {
	      Psymbol *ps;

	      if (ps = Plookup(yytext[0]))
	      {
		 if ((yylval.val.type = ps->pval.type ) == 1 )
		    yylval.val.u.s = ps->pval.u.s;
		 else
		    for ( i=0; i < yylval.val.type; i++ )
		       yylval.val.u.v[i] = ps->pval.u.v[i];

	         return NUMBER;
	      }
	   }

	   for ( i = 0; i < F_dim; i++ )
	      if ( yytext[0] == Param[i] )
	      {
	         yylval.val.u.s = Parval[i];
		 yylval.val.type = 1;
		 return NUMBER;
	      }
	}

	if ( (s=lookup( yytext )) == 0 )
	   s = install( yytext, UNDEF, 0, 0 );

	yylval.sym = s;
	return ( s->class == UNDEF ? VAR : s->class );
	}
break;
case 4:
{
	    yylval.mfe = emalloc(yyleng);
	    strcpy(yylval.mfe, yytext);
	    return FDATEI;
        }
break;
case 5:
{ return ASSIGN; }
break;
case 6:
{ return ADDASS; }
break;
case 7:
{ return SUBASS; }
break;
case 8:
{ return MULASS; }
break;
case 9:
{ return DIVASS; }
break;
case 10:
{ return EXPASS; }
break;
case 11:
{ return FDEF; }
break;
case 12:
{ yytext[yyleng-1] = '#';
	    yylval.mfe = emalloc(yyleng-2);
	    strcpy(yylval.mfe, &yytext[2]);
	    return MFKTDEF; }
break;
case 13:
{ mfkdef = 1; return yytext[0]; }
break;
case 14:
{ mfkdef = 0; return yytext[0]; }
break;
case 15:
{ return END;  }
break;
case 16:
{ return EXIT; }
break;
case 17:
{ return LSTVAL; }
break;
case 18:
{ yylval.val.type = 0; return PVAL; }
break;
case 19:
{ yylval.val.type = 1; return PVAL; }
break;
case 20:
{ yylval.val.type = 2; return PVAL; }
break;
case 21:
{ yylval.val.type = -1; return PVAL; }
break;
case 22:
{ return IFTHEN; }
break;
case 23:
{ return LT; }
break;
case 24:
{ return LEQ; }
break;
case 25:
{ return GT; }
break;
case 26:
{ return GEQ; }
break;
case 27:
{ return EQ; }
break;
case 28:
{ return NEQ; }
break;
case 29:
{ return yytext[0]; }
break;
case -1:
break;
default:
   fprintf(yyout,"bad switch yylook %d",nstr);
} return(0); }
/* end of yylex */

static void __yy__unused() { main(); }
int yyvstop[] = {
0,

29,
0,

1,
29,
0,

16,
29,
0,

17,
29,
0,

29,
0,

29,
0,

29,
0,

29,
0,

29,
0,

2,
29,
0,

29,
0,

15,
29,
0,

23,
29,
0,

29,
0,

25,
29,
0,

29,
0,

3,
29,
0,

3,
29,
0,

13,
29,
0,

14,
29,
0,

29,
0,

29,
0,

29,
0,

8,
0,

6,
0,

7,
0,

2,
0,

9,
0,

2,
0,

2,
0,

11,
0,

5,
0,

24,
0,

27,
0,

26,
0,

21,
0,

20,
0,

18,
0,

19,
0,

3,
0,

3,
0,

10,
0,

28,
0,

12,
0,

22,
0,

2,
0,

4,
0,
0};
# define YYTYPE unsigned char
struct yywork { YYTYPE verify, advance; } yycrank[] = {
0,0,	0,0,	1,3,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	1,4,	1,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	51,0,	0,0,	
1,5,	0,0,	1,6,	0,0,	
0,0,	0,0,	0,0,	1,7,	
1,8,	0,0,	1,9,	1,10,	
1,11,	1,12,	2,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	1,13,	
1,14,	1,15,	1,16,	1,17,	
1,18,	7,26,	1,19,	8,27,	
9,28,	11,30,	1,19,	15,37,	
16,38,	17,39,	1,20,	2,5,	
13,34,	2,6,	13,35,	13,36,	
23,47,	25,48,	2,7,	51,51,	
0,0,	2,9,	2,10,	2,11,	
0,0,	0,0,	0,0,	0,0,	
1,21,	0,0,	1,22,	1,23,	
1,24,	29,49,	2,13,	2,14,	
2,15,	2,16,	2,17,	2,18,	
0,0,	0,0,	18,40,	0,0,	
18,41,	0,0,	0,0,	18,42,	
0,0,	2,20,	10,29,	10,29,	
10,29,	10,29,	10,29,	10,29,	
10,29,	10,29,	10,29,	10,29,	
18,43,	20,46,	0,0,	1,25,	
0,0,	29,49,	0,0,	2,21,	
0,0,	2,22,	2,23,	2,24,	
24,44,	0,0,	24,33,	24,33,	
24,33,	24,33,	24,33,	24,33,	
24,33,	24,33,	24,33,	24,33,	
12,31,	46,52,	12,32,	12,32,	
12,32,	12,32,	12,32,	12,32,	
12,32,	12,32,	12,32,	12,32,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2,25,	12,33,	
12,33,	12,33,	12,33,	12,33,	
12,33,	12,33,	12,33,	12,33,	
12,33,	12,33,	12,33,	12,33,	
12,33,	12,33,	12,33,	12,33,	
12,33,	12,33,	12,33,	12,33,	
12,33,	12,33,	12,33,	12,33,	
12,33,	0,0,	0,0,	0,0,	
0,0,	12,33,	0,0,	12,33,	
12,33,	12,33,	12,33,	12,33,	
12,33,	12,33,	12,33,	12,33,	
12,33,	12,33,	12,33,	12,33,	
12,33,	12,33,	12,33,	12,33,	
12,33,	12,33,	12,33,	12,33,	
12,33,	12,33,	12,33,	12,33,	
12,33,	19,44,	0,0,	19,45,	
19,45,	19,45,	19,45,	19,45,	
19,45,	19,45,	19,45,	19,45,	
19,45,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
19,45,	19,45,	19,45,	19,45,	
19,45,	19,45,	19,45,	19,45,	
19,45,	19,45,	19,45,	19,45,	
19,45,	19,45,	19,45,	19,45,	
19,45,	19,45,	19,45,	19,45,	
19,45,	19,45,	19,45,	19,45,	
19,45,	19,45,	0,0,	0,0,	
0,0,	0,0,	19,45,	0,0,	
19,45,	19,45,	19,45,	19,45,	
19,45,	19,45,	19,45,	19,45,	
19,45,	19,45,	19,45,	19,45,	
19,45,	19,45,	19,45,	19,45,	
19,45,	19,45,	19,45,	19,45,	
19,45,	19,45,	19,45,	19,45,	
19,45,	19,45,	31,29,	31,29,	
31,29,	31,29,	31,29,	31,29,	
31,29,	31,29,	31,29,	31,29,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	31,50,	
31,50,	31,50,	31,50,	31,50,	
31,50,	31,50,	31,50,	31,50,	
31,50,	31,50,	31,50,	31,50,	
31,50,	31,50,	31,50,	31,50,	
31,50,	31,50,	31,50,	31,50,	
31,50,	31,50,	31,50,	31,50,	
31,50,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	31,50,	
31,50,	31,50,	31,50,	31,50,	
31,50,	31,50,	31,50,	31,50,	
31,50,	31,50,	31,50,	31,50,	
31,50,	31,50,	31,50,	31,50,	
31,50,	31,50,	31,50,	31,50,	
31,50,	31,50,	31,50,	31,50,	
31,50,	33,44,	0,0,	33,33,	
33,33,	33,33,	33,33,	33,33,	
33,33,	33,33,	33,33,	33,33,	
33,33,	34,34,	0,0,	0,0,	
0,0,	0,0,	49,53,	0,0,	
49,53,	34,34,	34,0,	49,54,	
49,54,	49,54,	49,54,	49,54,	
49,54,	49,54,	49,54,	49,54,	
49,54,	53,54,	53,54,	53,54,	
53,54,	53,54,	53,54,	53,54,	
53,54,	53,54,	53,54,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	34,34,	
0,0,	0,0,	0,0,	0,0,	
34,34,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	34,51,	
0,0,	0,0,	0,0,	0,0,	
0,0,	34,34,	0,0,	0,0,	
0,0,	34,34,	44,50,	44,50,	
44,50,	44,50,	44,50,	44,50,	
44,50,	44,50,	44,50,	44,50,	
44,50,	44,50,	44,50,	44,50,	
44,50,	44,50,	44,50,	44,50,	
44,50,	44,50,	44,50,	44,50,	
44,50,	44,50,	44,50,	44,50,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	44,50,	44,50,	
44,50,	44,50,	44,50,	44,50,	
44,50,	44,50,	44,50,	44,50,	
44,50,	44,50,	44,50,	44,50,	
44,50,	44,50,	44,50,	44,50,	
44,50,	44,50,	44,50,	44,50,	
44,50,	44,50,	44,50,	44,50,	
50,55,	50,55,	50,55,	50,55,	
50,55,	50,55,	50,55,	50,55,	
50,55,	50,55,	50,55,	50,55,	
50,55,	50,55,	50,55,	50,55,	
50,55,	50,55,	50,55,	50,55,	
50,55,	50,55,	50,55,	50,55,	
50,55,	50,55,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
50,55,	50,55,	50,55,	50,55,	
50,55,	50,55,	50,55,	50,55,	
50,55,	50,55,	50,55,	50,55,	
50,55,	50,55,	50,55,	50,55,	
50,55,	50,55,	50,55,	50,55,	
50,55,	50,55,	50,55,	50,55,	
50,55,	50,55,	0,0,	0,0,	
0,0};
struct yysvf yysvec[] = {
0,	0,	0,
-1,	0,		0,	
-40,	yysvec+1,	0,	
0,	0,		yyvstop+1,
0,	0,		yyvstop+3,
0,	0,		yyvstop+6,
0,	0,		yyvstop+9,
4,	0,		yyvstop+12,
6,	0,		yyvstop+14,
7,	0,		yyvstop+16,
66,	0,		yyvstop+18,
8,	0,		yyvstop+20,
102,	0,		yyvstop+22,
18,	0,		yyvstop+25,
0,	0,		yyvstop+27,
10,	0,		yyvstop+30,
11,	0,		yyvstop+33,
12,	0,		yyvstop+35,
9,	0,		yyvstop+38,
179,	0,		yyvstop+40,
23,	yysvec+19,	yyvstop+43,
0,	0,		yyvstop+46,
0,	0,		yyvstop+49,
19,	0,		yyvstop+52,
90,	yysvec+12,	yyvstop+54,
20,	0,		yyvstop+56,
0,	0,		yyvstop+58,
0,	0,		yyvstop+60,
0,	0,		yyvstop+62,
28,	yysvec+10,	yyvstop+64,
0,	0,		yyvstop+66,
254,	0,		yyvstop+68,
0,	yysvec+12,	yyvstop+70,
331,	yysvec+12,	0,	
-388,	0,		0,	
0,	0,		yyvstop+72,
0,	0,		yyvstop+74,
0,	0,		yyvstop+76,
0,	0,		yyvstop+78,
0,	0,		yyvstop+80,
0,	0,		yyvstop+82,
0,	0,		yyvstop+84,
0,	0,		yyvstop+86,
0,	0,		yyvstop+88,
393,	0,		0,	
0,	yysvec+19,	yyvstop+90,
26,	yysvec+19,	yyvstop+92,
0,	0,		yyvstop+94,
0,	0,		yyvstop+96,
351,	0,		0,	
451,	0,		0,	
-24,	yysvec+34,	yyvstop+98,
0,	0,		yyvstop+100,
361,	0,		0,	
0,	yysvec+53,	yyvstop+102,
0,	0,		yyvstop+104,
0,	0,	0};
struct yywork *yytop = yycrank+573;
struct yysvf *yybgin = yysvec+1;
unsigned char yymatch[] = {
00  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,011 ,012 ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
011 ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,'+' ,01  ,'+' ,01  ,01  ,
'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,
'0' ,'0' ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,'A' ,'A' ,'A' ,'A' ,'E' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,01  ,01  ,01  ,01  ,01  ,
01  ,'A' ,'A' ,'A' ,'A' ,'E' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
0};
unsigned char yyextra[] = {
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0};
/* @(#) $Revision: 70.1 $      */
int yylineno =1;
# define YYU(x) x
# define NLSTATE yyprevious=YYNEWLINE
 
#ifdef YYNLS16_WCHAR
unsigned char yytextuc[YYLMAX * sizeof(wchar_t)];
# ifdef YY_PCT_POINT /* for %pointer */
wchar_t yytextarr[YYLMAX];
wchar_t *yytext;
# else               /* %array */
wchar_t yytextarr[1];
wchar_t yytext[YYLMAX];
# endif
#else
unsigned char yytextuc;
# ifdef YY_PCT_POINT /* for %pointer */
unsigned char yytextarr[YYLMAX];
unsigned char *yytext;
# else               /* %array */
unsigned char yytextarr[1];
unsigned char yytext[YYLMAX];
# endif
#endif

struct yysvf *yylstate [YYLMAX], **yylsp, **yyolsp;
unsigned char yysbuf[YYLMAX];
unsigned char *yysptr = yysbuf;
int *yyfnd;
extern struct yysvf *yyestate;
int yyprevious = YYNEWLINE;
yylook(){
	register struct yysvf *yystate, **lsp;
	register struct yywork *yyt;
	struct yysvf *yyz;
	int yych, yyfirst;
	struct yywork *yyr;
FILE *yyin = {stdin}, *yyout = {stdout};
# ifdef LEXDEBUG
	int debug;
# endif
/*	char *yylastch;
 * ***** nls8 ***** */
	unsigned char *yylastch, sec;
	/* start off machines */
# ifdef LEXDEBUG
	debug = 0;
# endif
	yyfirst=1;
	if (!yymorfg)
#ifdef YYNLS16_WCHAR
		yylastch = yytextuc;
#else
		yylastch = yytext;
#endif
	else {
		yymorfg=0;
#ifdef YYNLS16_WCHAR
		yylastch = yytextuc+yylenguc;
#else
		yylastch = yytext+yyleng;
#endif
		}
	for(;;){
		lsp = yylstate;
		yyestate = yystate = yybgin;
		if (yyprevious==YYNEWLINE) yystate++;
		for (;;){
# ifdef LEXDEBUG
			if(debug)fprintf(yyout,"state %d\n",yystate-yysvec-1);
# endif
			yyt = &yycrank[yystate->yystoff];
			if(yyt == yycrank && !yyfirst){  /* may not be any transitions */
				yyz = yystate->yyother;
				if(yyz == 0)break;
				if(yyz->yystoff == 0)break;
				}
			*yylastch++ = yych = input();
			yyfirst=0;
		tryagain:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"char ");
				allprint(yych);
				putchar('\n');
				}
# endif
			yyr = yyt;
			if ( (int)yyt > (int)yycrank){
				yyt = yyr + yych;
				if (yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				}
# ifdef YYOPTIM
			else if((int)yyt < (int)yycrank) {		/* r < yycrank */
				yyt = yyr = yycrank+(yycrank-yyt);
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"compressed state\n");
# endif
				yyt = yyt + yych;
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				yyt = yyr + YYU(yymatch[yych]);
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"try fall back character ");
					allprint(YYU(yymatch[yych]));
					putchar('\n');
					}
# endif
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transition */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				}
			if ((yystate = yystate->yyother) && (yyt = &yycrank[yystate->yystoff]) != yycrank){
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"fall back to state %d\n",yystate-yysvec-1);
# endif
				goto tryagain;
				}
# endif
			else
				{unput(*--yylastch);break;}
		contin:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"state %d char ",yystate-yysvec-1);
				allprint(yych);
				putchar('\n');
				}
# endif
			;
			}
# ifdef LEXDEBUG
		if(debug){
			fprintf(yyout,"stopped at %d with ",*(lsp-1)-yysvec-1);
			allprint(yych);
			putchar('\n');
			}
# endif
		while (lsp-- > yylstate){
			*yylastch-- = 0;
			if (*lsp != 0 && (yyfnd= (*lsp)->yystops) && *yyfnd > 0){
				yyolsp = lsp;
				if(yyextra[*yyfnd]){		/* must backup */
					while(yyback((*lsp)->yystops,-*yyfnd) != 1 && lsp > yylstate){
						lsp--;
						unput(*yylastch--);
						}
					}
				yyprevious = YYU(*yylastch);
				yylsp = lsp;
#ifdef YYNLS16_WCHAR
				yylenguc = yylastch-yytextuc+1;
				yytextuc[yylenguc] = 0;
#else
				yyleng = yylastch-yytext+1;
				yytext[yyleng] = 0;
#endif
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"\nmatch ");
#ifdef YYNLS16_WCHAR
					sprint(yytextuc);
#else
					sprint(yytext);
#endif
					fprintf(yyout," action %d\n",*yyfnd);
					}
# endif
				return(*yyfnd++);
				}
			unput(*yylastch);
			}
#ifdef YYNLS16_WCHAR
		if (yytextuc[0] == 0  /* && feof(yyin) */)
#else
		if (yytext[0] == 0  /* && feof(yyin) */)
#endif
			{
			yysptr=yysbuf;
			return(0);
			}
#ifdef YYNLS16_WCHAR
		yyprevious = yytextuc[0] = input();
#else
		yyprevious = yytext[0] = input();
#endif
		if (yyprevious>0) {
			output(yyprevious);
#ifdef YYNLS16
                        if (yynls16)
#ifdef YYNLS16_WCHAR
                        	if (FIRSTof2(yytextuc[0]))
#else
                        	if (FIRSTof2(yytext[0]))
#endif
     					if (SECof2(sec = input()))
#ifdef YYNLS16_WCHAR
 						output(yyprevious=yytextuc[0]=sec);
#else
 						output(yyprevious=yytext[0]=sec);
#endif
					else 
						unput(sec);
#endif
                }
#ifdef YYNLS16_WCHAR
		yylastch=yytextuc;
#else
		yylastch=yytext;
#endif
# ifdef LEXDEBUG
		if(debug)putchar('\n');
# endif
		}
	}

# ifdef __cplusplus
yyback(int *p, int m)
# else
yyback(p, m)
	int *p;
# endif
{
if (p==0) return(0);
while (*p)
	{
	if (*p++ == m)
		return(1);
	}
return(0);
}
	/* the following are only used in the lex library */
yyinput(){
	return(input());
	
	}

#ifdef __cplusplus
void yyoutput(int c)
#else
yyoutput(c)
  int c;
# endif
{
	output(c);
}

#ifdef __cplusplus
void yyunput(int c)
#else
yyunput(c)
   int c;
#endif
{
	unput(c);
}
